local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local config = {}
config.event = {}

local c = BittensSpellFlashLibrary2

function config.OtherAurasFunction()
    -- This is called before Spells.lua loads, so sadly we have to hard code
    -- the spell ids.
    s.SetOtherAuras(2948--[[Scorch]], 22959--[[Critical Mass]])
end

a.Phase = "neutral"
a.UnstackedMaxMana = 1000000000
function config.event.PLAYER_REGEN_ENABLED(event)
    -- why on earth is this the event for leaving combat,
    -- and not "PLAYER_LEAVE_COMBAT"??
    a.Phase = "neutral"
    a.UnstackedMaxMana = 1000000000
end

local blizzFingerCount = -1
a.FingerCount = blizzFingerCount
function config.event.COMBAT_LOG_EVENT_UNFILTERED(event, ...)
    event = select(2, ...)
    source = select(5, ...)
    if (event ~= "SPELL_CAST_SUCCESS" and event ~= "SPELL_CAST_START")
        or not UnitIsUnit(source, "player") then
        
        return
    end
    
    c.Init(AddonName, a)
    local id = select(12, ...)
    if id == c.GetID("Ice Lance")
        or id == c.GetID("Frostfire Bolt")
        or id == c.GetID("Deep Freeze") then
        
        a.FingerCount = math.max(0, a.FingerCount - 1)
        c.Debug("Event", "Pretend FoF is now at", a.FingerCount)
    end
end
-- Why didn't this work?
--function config.event.UNIT_SPELLCAST_SUCCEEDED(
--    event, unit, spell, rank, lineID, spellID)
--    
--    print("spellcast succeeded:", unit)
--    if not UnitIsUnit(unit, "player") then
--        return
--    end
--    
--    c.Init(AddonName, a)
--    if spellID == c.GetID("Ice Lance")
--        or spellID == c.GetID("Frostfire Bolt") then
--        
--        a.FingerCount = math.max(0, a.FingerCount - 1)
--        c.Debug("Event", "Pretend FoF is now at", a.FingerCount)
--    end
--end

a.StolenTimeRemaining = 0
local lastStolenTimeDuration = 0
local lastStolenTimeObserved = 0
function config.event.UNIT_AURA(event, unit)
    if not UnitIsUnit(unit, "player") then
        return
    end
    
    c.Init(AddonName, a)
    
    -- manage the Fingers of Frost count
    local stack = c.GetBuffStack("Fingers of Frost")
    if a.FingerCount < 0 then
        a.FingerCount = stack
        c.Debug("Event", "FoF initializing to", stack)
    elseif stack > blizzFingerCount then
        if a.FingerCount == blizzFingerCount - 1 then
            a.FingerCount = stack - 1
        else
            a.FingerCount = stack
        end
        c.Debug("Event",
            "Gained FoF. Stack =", stack, "Pretend =", a.FingerCount)
    elseif stack < blizzFingerCount then
        a.FingerCount = stack
        c.Debug("Event", "Lost FoF. Stack =", stack)
    end
    blizzFingerCount = stack
    
    -- manage 4pT13 stuff
    if c.WearingSet(4, "T13") then
        local duration = s.BuffDuration(c.GetID("Stolen Time"), "player")
        if duration == 0 then
            a.StolenTimeRemaining = 10
            c.Debug("Event", "Stolen Time Reset", 10)
        elseif duration 
            > lastStolenTimeDuration - (GetTime() - lastStolenTimeObserved) then
            
            if s.Buff(c.GetID("Arcane Power"), "player")
                or s.MyDebuff(c.GetID("Combustion"))
                or s.Buff(c.GetID("Icy Veins"), "player") then
            
                a.StolenTimeRemaining = 10
                c.Debug("Event", "Stolen Time Reset", 10)
            else
                a.StolenTimeRemaining = math.max(0, a.StolenTimeRemaining - 1)
                c.Debug("Event", "Stolen Time Bump", a.StolenTimeRemaining)
            end
        end
        lastStolenTimeDuration = duration
        lastStolenTimeObserved = GetTime()
    else
        a.StolenTimeRemaining = 0
    end
end

config.CheckButtonOptions = {
    LeftCheckButton1 = {
        DefaultChecked = true,
        ConfigKey = "arcane_off",
        Label = L["Flash Arcane"],
    },
    LeftCheckButton2 = {
        DefaultChecked = true,
        ConfigKey = "fire_off",
        Label = L["Flash Fire"],
    },
    LeftCheckButton3 = {
        DefaultChecked = true,
        ConfigKey = "frost_off",
        Label = L["Flash Frost"],
    },
    LeftCheckButton4 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    LeftCheckButton5 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    LeftCheckButton6 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    LeftCheckButton7 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton1 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton2 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton3 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton4 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton5 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton6 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
    RightCheckButton7 = {
        DefaultChecked = true,
        ConfigKey = "My_Config_Key",
        Label = L["My_Check_Button_Label"],
    },
}

config.EditBoxOptions = {
	LeftEditBox1 = {
		DefaultValue = "45",
		Numeric = true,
		MaxCharacters = 3,
		ConfigKey = "burn_length",
		Label = L["Length of burn phase:"],
	},
	LeftEditBox2 = {
		DefaultValue = "28",
		Numeric = true,
		MaxCharacters = 2,
		ConfigKey = "evocate_percent",
		Label = L["Evocate at % mana:"],
	},
	RightEditBox1 = {
		DefaultValue = "92",
		Numeric = true,
		MaxCharacters = 2,
		ConfigKey = "missiles_percent",
		Label = L["Use Arcane Missiles below % mana:"],
	},
	RightEditBox2 = {
		DefaultValue = "",
		Numeric = false,
		MaxCharacters = 999,
		ConfigKey = "My_Config_Key",
		Label = L["My_Edit_Box_Label:"],
	},
}

a.LoadConfigs(config)